#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int m;
    cin >> m;
    vector<int> b(m);
    for (int i = 0; i < m; i++) {
        cin >> b[i];
    }

    vector<int> sufa(n + 1);
    for (int i = n - 1; i >= 0; i--) {
        sufa[i] = sufa[i + 1] + a[i];
    }

    vector<int> sufb(m + 1);
    for (int i = m - 1; i >= 0; i--) {
        sufb[i] = sufb[i + 1] + b[i];
    }

    vector<int> besta(n + 1, -1), bestb(m + 1, -1);

    int ca = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            ca++;
        }

        besta[ca] = max(besta[ca], sufa[i + 1]);
    }

    int cb = 0;
    for (int i = 0; i < m; i++) {
        if (b[i] == 0) {
            cb++;
        }

        bestb[cb] = max(bestb[cb], sufb[i + 1]);
    }

    int L = 0;
    int R = min(n, m) + 1;
    while (R - L > 1) {
        int M = (L + R) / 2;

        bool ok = false;
        for (int z = 0; z <= M; z++) {
            if (besta[z] >= M - z && bestb[z] >= M - z) {
                ok = true;
                break;
            }
        }

        if (ok) {
            L = M;
        } else {
            R = M;
        }
    }

    cout << L << endl;

    return 0;
}
